/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.cvut.felk.newsgroup.preprocess;

import java.io.*;
import java.util.*;
import java.util.ArrayList;
import static cz.cvut.felk.newsgroup.preprocess.StringUtils.*;

/**
 * Model defines the vector-representation of a textual file.
 *
 * <p>Roughly speaking, the model is a list of "columns" titles,
 * which define the dataset. They are the words, which can be either
 * present or missing in a testing example.</p>
 *
 * <p>This class defines the model and contains a method to convert
 * an text file into an model-instance.</p>
 */
public class Model extends ArrayList<String> {

    /**
     * Creates an vector instance from a file under this model.
     */
    public List<Boolean> fileToVector(BufferedReader fileContent)
                                                    throws IOException{

        // Initialize the vector representation with all "false"s.
        final List<Boolean> output = new ArrayList<Boolean>(this.size());
        for (int i = 0; i < this.size(); i++)
            output.add(false);

        // For each word in the file...
        for (String word : tokenize( fileContent.readLine() )) {
            word = processWord(word);

            // ... is the file in the model-defining vector?
            int index = this.indexOf(word);

            // If yes, set the vector representation to "true".
            if (index != -1)
                output.set(index, true);
        }

        return output;
    }
}
